-- io = nil
os = nil
-- debug = nil
require = nil
module = nil
package = nil
set_state = nil

-- TODO: Move to kolproxy core(?)
raw_input_params = params
params = nil

dofile("scripts/base/util.lua")

kolproxy_log_time_interval("do params", function()
input_params = raw_input_params
params = parse_params(raw_input_params)
end)

function wrapped_function()

local mods = {}

kolproxy_log_time_interval("mods setup", function()
if text:match([[src="[^"]*%?[^"]*.js"]]) then
	print("\n\n\n=======\n\n\n", "Warning: ? query js file (CDM should fix this)", path, text:match([[src="[^"]*%?[^"]*.js"]]), "\n\n\n=======\n\n\n")
end

if path == "/login.php" then
	local current_version = get_current_kolproxy_version()
	local latest_version = get_latest_kolproxy_version()
	mods["/login.php"] = {
		[ [[<input class=button type=submit value="Log In" name=submitbutton id=submitbutton>]] ] = [[<input class="button" type="submit" value="Log In" style="color: gray" name="submitbutton" id="submitbutton" disabled="disabled">]],
		["<font size=1>If you've forgotten your password"] = [[<div id="jswarning" style="color: red">You have to turn on javascript, otherwise you'll submit your password in cleartext!</div><script type="text/javascript">if (md5s) { document.getElementById('jswarning').style.display = 'none'; document.getElementById('submitbutton').value = 'Log In'; document.getElementById('submitbutton').disabled = ''; document.getElementById('submitbutton').style.color = 'black'; }</script>%0]],
	}
	if latest_version and current_version ~= latest_version then
		print("current version", current_version, "latest version", latest_version)
		mods["/login.php"]["An Adventurer is You!<br>"] = [[An Adventurer is You!<br><a href="http://www.houeland.com/kolproxy/wiki/Installation" target="_blank" style="color: darkorange; text-decoration: none;">{kolproxy ]]..current_version..[[, latest version is ]]..latest_version..[[}</a><br><a href="http://www.houeland.com/kolproxy/wiki/Installation" target="_blank" style="color: darkorange; font-size: smaller;">{Click here to upgrade.}</a>]]
	else
		mods["/login.php"]["An Adventurer is You!<br>"] = [[An Adventurer is You!<br><span style="color: green">{kolproxy ]]..current_version..[[}</span><br>]]
	end
end

mods["/game.php"] = {
	["chatlaunch.php"] = "lchat.php"
}

mods["/lchat.php"] = {
	["font%-size: 12px;"] = "font-size: 13px;",
-- 	["getnewchat%(last,repeat%) {"] = [[%0 console.log("getnewchat", last, repeat, chatTimer);]],
-- 	["nextCycle%(repeat%) {"] = [[%0 console.log("nextCycle", repeat, chatTimer);]],
-- 	["complete: function %(%) {"] = [[complete: function (a, b) { console.log("complete", a, b);]],
}

-- mods["/bhh.php"] = {
-- 	["<form method=post action=bhh.php><input type=hidden name=pwd value=%x+><input type=hidden name=action value=\"abandonbounty\"><center><input type=submit class=button value=\"I Give Up!\"></center></form>"] =
-- 		"<center><a href=\"automate-bhh\" style=\"color:green\">{automate}</a></center><p>%0",
-- }

mods["/showplayer.php"] = { -- This can also be done by adding header_noframecheck=1 to the URL query
	[ [[if %(parent.frames.length == 0%) location.href="game.php";]] ] = ""
}

local pwd = "?"

if can_read_state() == "yes" then
	pwd = get_session_state("pwd") -- TODO: eww, pwd insertion
end

mods["/compactmenu.php"] = {
	[ [[<option value="logout.php">Log Out</option>]] ] = [[%0<option value="nothing">- Select -</option>]],
	[ [[<option value="account.php">Account Menu</option>]] ] = [[%0<option value="custom-settings?pwd=]] .. pwd .. [[">Kolproxy Settings</option>]],
}

mods["/topmenu.php"] = {
	[ [[<option value="logout.php">Log Out</option>]] ] = [[<option value="logout.php">Log Out</option><option value="nothing">- Select -</option>]],
	[ [[<option value="account.php">Options</option>]] ] = [[%0<option value="custom-settings?pwd=]] .. pwd .. [[">Kolproxy Settings</option>]],
}

mods["/loggedout.php"] = {
	[ [[<a href="http://[a-z0-9]-.kingdomofloathing.com/login.php">([^<]-)</a>]] ] = [[<a href="/" style="color:green">{%1}</a>]],
}

mods["/main.php"] = {
	[ [[title="Bottom Edge"></td></tr>.</table>]] ] = [[%0<table><tr><td><a href="custom-settings?pwd=]] .. pwd .. [[" style="color: green">{ Kolproxy settings }</a></td></tr></table>]]
}

mods["/charsheet.php"] = {
	[ [[>Ascensions:</a></td><td><b>[0-9,.]-</b>]] ] = [[%0 <a href="custom-logs" style="color:green">{View logs}</a>]]
}
end)

kolproxy_log_time_interval("mods run", function()
for from, to in pairs(mods[path] or {}) do
	text = text:gsub(from, to)
end
end)

if can_read_state() ~= "yes" then
	return text
end

local printers = {}
local noncombat_choice_texts = {}

function get_noncombat_choice_spoilers(advtitle)
	return noncombat_choice_texts[advtitle]
end

local function add_printer_raw(scriptname, file, func)
	if not printers[file] then printers[file] = {} end
	table.insert(printers[file], { scriptname = scriptname, f = func })
end

local function add_choice_text_conditional_raw(scriptname, title, data, test)
	if not noncombat_choice_texts[title] then noncombat_choice_texts[title] = {} end
	table.insert(noncombat_choice_texts[title], { test = test, data = data, scriptname = scriptname })
end

kolproxy_log_time_interval("load_script_files call", function ()
load_script_files {
	add_processor = function () end,
	add_printer = function (file, func) add_printer_raw(name, file, func) end,
	add_choice_text = function (title, x) add_choice_text_conditional_raw(name, title, x, function() return true end) end,
	add_choice_text_conditional = function (title, tbl, func)
		print("add_choice_text_conditional() is deprecated, use add_choice_text() with a function instead")
		add_choice_text_conditional_raw(name, title, tbl, func)
	end,
	add_choice_itemtext = function (title, tbl)
		print("add_choice_itemtext() is deprecated, call add_choice_text() instead")
		add_choice_text_conditional_raw(name, title, tbl, function() return true end)
	end,
	add_choice_function = function (title, f)
		print("add_choice_function() is deprecated, call add_choice_text() instead")
		add_choice_text_conditional_raw(name, title, f, function() return true end)
	end,
	add_interceptor = function () end,
	add_automator = function () end,
}
end)

if path == "/charpane.php" then
	text = text:gsub([[(<td align=right>Meat:.-)(</table>)]], "%1<!-- charpane compact text space -->%2")
	text = text:gsub([[(src="http://images.kingdomofloathing.com/itemimages/hourglass.gif".-</table>)]], "%1<!-- charpane normal text space -->")

	text = text:gsub([[(<a target=mainpane href="familiar.php" class="familiarpick"><img src="http://images.kingdomofloathing.com/itemimages/)([^"]-)(.gif" width=30 height=30 border=0></a><br>)([0-9]+)( lb.-)(</center>)]], "%1%2%3%4%5<!-- charpane compact familiar text space type{%2} weight{%4} -->%6") -- TODO-future: redo without .-?
	text = text:gsub([[(<a target=mainpane href="familiar.php" class="familiarpick"><img src="http://images.kingdomofloathing.com/itemimages/)([^"]-)(.gif" width=30 height=30 border=0>.- <b>)([0-9]+)(</b> pound .-)(</table></center>)]], "%1%2%3%4%5<!-- charpane normal familiar text space type{%2} weight{%4} -->%6") -- TODO-future: redo without .-!
end

kolproxy_log_time_interval("setup variables", setup_variables)
kolproxy_log_time_interval("setup functions", setup_functions)

kolproxy_log_time_interval("do run_functions", function()
if path == "/charpane.php" and text:contains("inf_small.gif") then
	-- Hack for valhalla
else
	text = run_functions(path, text, function (target, pt)
		for _, x in ipairs(printers[target] or {}) do
			getfenv(x.f).text = pt
			x.f()
			pt = getfenv(x.f).text
		end
		return pt
	end)
end
end)

if fight_is_over == true then
-- 	print("resetting fight state!")
	reset_fight_state()
end

if path == "/charpane.php" then
kolproxy_log_time_interval("do charpane lines", function()
	text = print_charpane_lines(text)
end)
end

-- TODO: Redo!
if choice_adventure_number or path == "/choice.php" then
kolproxy_log_time_interval("do choice page", function()
	do_loadfile("base/choice-page.lua")
end)
end

if text:contains("charpane.php") then
	if path:contains("afterlife.php") or path:contains("charpane.php") then
	else
		-- ensure API load before returning page
kolproxy_log_time_interval("do ensure-status", function()
		status()
end)
	end
end

-- if path ~= "/charpane.php" then
-- 	print(text)
-- end

-- print(pcall(status))

return text

end

do
	function do_loadfile(scriptname)
		local f, e = loadfile("scripts/" .. scriptname)
		if not f then error(e, 2) end
		setfenv(f, _G)
		f()
	end

	local g_store = {}
	local g_env = {}
	setmetatable(g_env, { __index = function(t, k)
		local v = rawget(g_store, k)
		if v ~= nil then return v end
		return _G[k]
	end, __newindex = function(t, k, v)
		g_store[k] = v
	end	})
	g_env._G = g_env
	setfenv(do_loadfile, g_env)
	setfenv(wrapped_function, g_env)
end

return wrapped_function()
